/*//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/ /////////////////////////////fe.fwd 1.1 : dynamic forwarding of any message to a named received objec/////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////*/

inlets=2;

autowatch=1;

// shows external credits only once per Max session
g=new Global("loaded");
if (!g.alreadyhere)
	{
	post("\r [fe.fwd] v1.4 | August 8 2006");
	g.alreadyhere=true;
	}
	
//var staticname=null;
var dynamicname=null;
var prefix=jsarguments[1];
var verbose=0;
var keep=false;
if (jsarguments[2]=="keep") keep=true;
var staticnames=null;
/////////////////////////////////////////////////////////info///////////////////////////////////////////////////////////////
function info(a){
	verbose=a;
}
/////////////////////////////////////////////////////////wipe//////////////////////////////////////////////////////////////
function wipe(){
	staticnames=null;
	dynamicname=null;
	if (verbose==1) post("\n [js fe.fwd] unbound");
	if (jsarguments[1]){
		prefix=jsarguments[1];
		if (verbose==1) post("\n [js fe.fwd] prefix "+prefix+" recovered");
	}
}
/////////////////////////////////////////////////////////set////////////////////////////////////////////////////////////////
function set(){
	var args=arrayfromargs(messagename, arguments);
	if (args.length==2) 
	{
		staticnames = new Array(args[1]);
		//staticnames[0]=args[1];
		if (verbose==1) post("\n [js fe.fwd] bounded to "+staticnames[0]);
	}
	if (args.length>2)
	{
		staticnames=new Array();
		for (i=1;i<args.length;i++)
		{
			staticnames[i-1]=args[i];
			if (verbose==1) post("\n [js fe.fwd] bounded to "+staticnames[i-1]);
		}
	}
	prefix=null;	
}
/////////////////////////////////////////////////////////data type & errors//////////////////////////////////////////////////
function msg_int(a){
	var tempmess=a;
	if ((staticnames==null) && (inlet==0)) post("\n [js fe.fwd]: error: no bound [receive] object!");
	if ((inlet==1) && (!prefix)) post("\n [js fe.fwd]: error: (int) bad argument for [receive] object name!");
	if ((inlet==1) && (prefix)) {
		dynamicname=prefix+a;
		staticnames=null;
	}
	if ((staticnames!=null) && (inlet==0)) 
	{
		for (i=0;i<staticnames.length;i++) forward(staticnames[i],tempmess);
	}
}
function msg_float(a){
	var tempmess=a;
	if ((staticnames==null) && (inlet==0)) post("\n [js fe.fwd]: error: no bound [receive] object!");
	if ((inlet==1) && (!prefix)) post("\n [js fe.fwd]: error: (float) bad argument for [receive] object name!");
	if ((inlet==1) && (prefix)){
		dynamicname=prefix+a;
		staticnames=null;
	}
	if ((staticnames!=null) && (inlet==0))
	{
		for (i=0;i<staticnames.length;i++) forward(staticnames[i],tempmess);
	}
}
function list(){
	
	if ((staticnames==null) && (inlet==0) && (!prefix)) post("\n [js fe.fwd]: error: no bound [receive] object!");
	if ((staticnames!=null) && (inlet==0) && (!prefix)) {
		var tempmess=new Array();
		for (i=0;i<arguments.length;i++) tempmess[i]=arguments[i];
		for (i=0;i<staticnames.length;i++) forward(staticnames[i],tempmess);
	}
	if ((staticnames==null) && (inlet==0) && (prefix) && (!keep)) {
		dynamicname=(prefix+arguments[0]); 
		var tempmess=new Array();
		for (i=0;i<arguments.length-1;i++) tempmess[i]=arguments[i+1];
		forward(dynamicname,tempmess);
	}
	if ((staticnames==null) && (inlet==0) && (prefix) && (keep) && (dynamicname!=null)) { 
		var tempmess=new Array();
		for (i=0;i<arguments.length-1;i++) tempmess[i]=arguments[i+1];
		forward(dynamicname,tempmess);
	}
	if ((staticnames==null) && (inlet==0) && (prefix) && (keep) && (dynamicname==null)) {
		post("\n[js fe.fwd] please, provide a dynamic name argument!");
			}
	if (inlet==1) post("\n [js fe.fwd]: error: (list) bad argument for [receive] object name!");
}
/////////////////////////////////////////////////////////anything///////////////////////////////////////////////////////////

function anything(){
	
	if (inlet==1){
		var mess=arrayfromargs(messagename, arguments);
		prefix=null;
		staticnames = new Array();
		for (i=0;i<mess.length;i++)
		{
			staticnames[i]=mess[i];
			if (verbose==1) post("\n [js fe.fwd] bounded to "+staticnames[i]);
		}
	}
	// STATIC MODE
	if ((inlet==0) && (!staticnames) && (!prefix)){
		var mess=arrayfromargs(messagename, arguments);
			if (mess.length>2) {
				var finalmess=new Array();
				for (i=1;i<mess.length;i++)
					finalmess[i-1]=mess[i];
				}
			else if (mess.length==2){ var finalmess=mess[1]; }
		forward(mess[0],finalmess);
	}
	if ((inlet==0) && (staticnames)){
		var mess=arrayfromargs(messagename, arguments);
		//if ((mess.length==1) && (mess[0]!=staticname)) forward(staticname,mess);
		if (mess.length==1) 
		{
			for (i=0;i<staticnames.length;i++) forward(staticnames[i],mess);
		}
		//if (mess.length>1) && (mess[0]==staticname)){
		if (mess.length>1){
			var finalmess=new Array();
			for (i=0;i<mess.length;i++) finalmess[i]=mess[i];
			for (i=0;i<staticnames.length;i++) forward(staticnames[i],finalmess);
		}
	}
	// PREFIX MODE
	if ((inlet==0) && (!staticnames) && (prefix) && (arguments.length>0) && (!keep)) {
	var mess = arrayfromargs(messagename, arguments);
		dynamicname=(prefix+mess[0]);
		if (mess.length>2) 
		{
			var finalmess=new Array();
			for (i=1;i<mess.length;i++) finalmess[i-1]=mess[i];
			forward(dynamicname, finalmess);
		}
		else if (mess.length==2)forward(dynamicname,mess[1]);
	}
	if ((inlet==0) && (!staticnames) && (prefix) && (arguments.length==0) && (!keep)) post("\n[js fe.fwd] please, provide a dynamic name argument!");
	/*
	if ((inlet==0) && (!staticnames) && (dynamicname) && (keep)){
		var mess=arrayfromargs(messagename, arguments);
		forward(dynamicname,mess);
		}
	*/
	if ((inlet==0) && (!staticnames) && (!dynamicname) && (arguments.length>0) && (!keep)){
		post("\n[js fe.fwd] please, provide a dynamic name argument!");
		}		
		
	if ((inlet==0) && (!staticnames) && (!dynamicname) && (keep)){
		post("\n[js fe.fwd] please, provide a dynamic name argument!");
		}		
}


/////////////////////////////////////////////////////////forward///////////////////////////////////////////////////////////

forward.local = 1;
function forward(who, what){
		if (verbose==1) post("\n send "+what+" to [receive "+who+"] object");
		g = new Global("r_obj");
		g.val = what;
		g.sendnamed(who,"val");
}

/////////////////////////////////////////////////////////feed/////////////////////////////////////////////////////////////

function feed()
	{
	if (prefix){
		var tempmess=arrayfromargs(arguments);
		var mess=new Array();
		for (i=0;i<tempmess.length-1;i++) mess[i]=tempmess[i+1];
		if (verbose==1) post("\n feed from "+prefix+"1 to "+prefix+tempmess[0]+" message : "+mess);
		for (i=1;i<tempmess[0]+1;i++){
			dynamicname=(prefix+i);
			forward(dynamicname, mess);
			}
		}
	else { post("\n [js fe.fwd] (feed) error: no prefix");}
	}
/////////////////////////////////////////////////////////check/////////////////////////////////////////////////////////////	
function check()
	{
	post("\n staticname(s): "+staticnames);
	//for (i=0;i<staticnames.length;i++) post("\n staticname "+i"+: "+staticnames[i]);
	post("\n dynamicname: "+dynamicname);
	post("\n prefix: "+prefix);
	post("\n keep: "+keep);
	}
/////////////////////////////////////////////////////////keep/////////////////////////////////////////////////////////////	
function keepmode(b)
	{
	if (b==1) 
		{
		keep=true;
		wipe();
		}
	if (b==0) keep=false;
	if (verbose==1) post("\n[js fe.fwd] keep option "+keep);
		
	}
	